#!/usr/bin/perl -w

$u_login = getlogin || getpwuid($<);
print "$u_login\n";
$mailbox= "/var/spool/mail/".$u_login ;
$config_file= $ENV{'HOME'};
$config_file .= "/".".sortmailrc";

open(NEWMAIL, $mailbox) or die "Cannot open $mailbox";
open(CONFIG, $config_file) or die "Cannot open $config_file";

# Read Config file
$found_default=0;
while (<CONFIG>) {
    $found_default=1 if (/default_folder/);
    /([^:]*):(.*)/;
    $folder{$1}=$2;
}
close(CONFIG);
die "Didn't find default entry in config file. Bailing out\n" unless ($found_default);

$prev="\n";
$writing=0;
while (<NEWMAIL>) {
	if ((/From .*:..:.. /) && (/@/) && ($prev eq "\n")) {
		$folder_found=0;
		foreach $current (keys(%folder)) {
			if (/$current/) {
				$folder_found=$current;
				last;
			}
		}
		if (!$folder_found) { $folder_found="default_folder" };
		if ($writing) { close(WRITEMAIL); };
		$writing=1;
		open(WRITEMAIL, ">>$folder{$folder_found}") or die "Could not open file $folder{$folder_found}";
		$count{$folder_found}++;
	}
	$prev=$_;
	if ($writing) { print WRITEMAIL; };	

}
foreach $cur (keys(%count)) {
	print "$count{$cur} mail saved in $folder{$cur}\n";
}

close (WRITEMAIL);
close (NEWMAIL);


